/*!
 * Web Sniffer v0.0.0.1 (https://5ms.ru/fktrk/)
 * Copyright 2019, 5MS
 * Licensed under MIT (http://en.wikipedia.org/wiki/MIT_License)
 */


chrome.browserAction.onClicked.addListener(function (tab) {
    chrome.tabs.create({url:'https://5ms.ru/fktrk/'}, function(tab) {

    });
});

function parse_url(url) {

    var parser = document.createElement('a');
    parser.href = url;

    /*
        parser.protocol; // => "http:"
        parser.host;     // => "example.com:3000"
        parser.hostname; // => "example.com"
        parser.port;     // => "3000"
        parser.pathname; // => "/pathname/"
        parser.hash;     // => "#hash"
        parser.search;   // => "?search=test"
    */

    return parser;
}


// https://easylist-downloads.adblockplus.org/malwaredomains_full.txt

var request = new XMLHttpRequest();
request.open('GET', 'https://5ms.ru/fktrk/list.json', true);

request.onload = function (e) {

    if (request.readyState === 4) {

        // Check if the get was successful.

        if (request.status === 200) {

            var hosts = JSON.parse(request.responseText);

            chrome.webRequest.onBeforeRequest.addListener(function (details) {
                    var url = parse_url(details.url);
                    for (var h in hosts) {

                        var reg = new RegExp(h, 'gi');
                        if (reg.test(url.hostname)) {

                            if (hosts[h].except !== undefined) {
                                reg = new RegExp('(' + hosts[h].except.join('|') + ')', 'gi');
                                if (reg.test(url.hostname)) {
                                    continue;
                                }
                            }
                            if (hosts[h].part !== undefined) {
                                reg = new RegExp('(' + hosts[h].part.join('|') + ')', 'gi');
                                if (reg.test(url.hostname)) {
                                    return {cancel: true};
                                } else {
                                    continue;
                                }
                            }

                            if (hosts[h].path !== undefined) {
                                reg = new RegExp('(' + hosts[h].path.join('|') + ')', 'gi');
                                if (reg.test(url.pathname)) {
                                    return {cancel: true};
                                } else {
                                    continue;
                                }
                            }

                            return {cancel: true};
                        }
                    }
                },
                {urls: ["<all_urls>"]},
                ["blocking"]
            );
        } else {
            console.error(request.statusText);
        }
    }
};

request.send(null);
